"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkLinks = void 0;
const broken_link_checker_1 = __importDefault(require("broken-link-checker"));
const checker_1 = __importDefault(require("./checker"));
const checkLinks = async (url, recursive, options, logger) => new Promise(resolve => {
    logger.log('=========================');
    logger.info('url:');
    console.log(url);
    logger.info('options:');
    console.log(options);
    logger.log('=========================');
    logger.log();
    const brokenLinks = Array();
    const notBrokenLinks = Array();
    const events = {
        junk: (result) => {
            logger.info('skipped: %s', result.url.original);
            logger.info(broken_link_checker_1.default[result.excludedReason]);
            logger.log();
            notBrokenLinks.push(result.url.original);
        },
        link: (result) => {
            if (result.broken) {
                logger.warn('broken: %s', result.url.original);
                logger.info(broken_link_checker_1.default[result.brokenReason]);
                brokenLinks.push({
                    originalURL: result.url.original,
                    redirectedURL: result.url.redirected,
                    brokenReason: result.brokenReason,
                });
            }
            else if (result.excluded) {
                logger.info('excluded: %s', result.url.original);
            }
            else {
                logger.info('passed: %s', result.url.original);
                notBrokenLinks.push(result.url.original);
            }
            logger.log();
        },
        end: () => resolve({ brokenLinks, notBrokenLinks }),
    };
    (new checker_1.default(recursive)).start(url, options, events);
});
exports.checkLinks = checkLinks;
